/***********************************************************************************************
* [IttyBitty_LCD_chars.h]: VALUE-ADDED SYMBOLS & ICONS FOR HD44780-COMPATIBLE LCD DISPLAYS
*
* This file is part of the Itty Bitty Arduino library.
* Copyright  2016 Thomas J. Biuso III  ALL RIGHTS RESERVED...WHATEVER THAT MEANS.
* RELEASED UNDER THE GPL v3.0 LICENSE; SEE <LICENSE> FILE WITHIN DISTRIBUTION ROOT FOR TERMS.
***********************************************************************************************/

#ifndef _ITTYBITTY_LCD_CHARS_H
#define _ITTYBITTY_LCD_CHARS_H


#include "IttyBitty_util.h"


#pragma region DEFINES

// LCD SYMBOL CHARACTERS

// ARROWS (Only ROM code A02 / English font)
#define LCD_SYMBOL_SCROLL_RIGHT			0x10
#define LCD_SYMBOL_FORWARD				LCD_SYMBOL_SCROLL_RIGHT
#define LCD_SYMBOL_NEXT					LCD_SYMBOL_SCROLL_RIGHT
#define LCD_SYMBOL_PLAY					LCD_SYMBOL_SCROLL_RIGHT
#define LCD_SYMBOL_SCROLL_LEFT			0x11
#define LCD_SYMBOL_BACKWARD				LCD_SYMBOL_SCROLL_LEFT
#define LCD_SYMBOL_REVERSE				LCD_SYMBOL_SCROLL_LEFT
#define LCD_SYMBOL_PREVIOUS				LCD_SYMBOL_SCROLL_LEFT
#define LCD_SYMBOL_DOUBLE_ARROW_UP		0x14
#define LCD_SYMBOL_TOP					LCD_SYMBOL_DOUBLE_ARROW_UP
#define LCD_SYMBOL_DOUBLE_ARROW_DOWN	0x15
#define LCD_SYMBOL_BOTTOM				LCD_SYMBOL_DOUBLE_ARROW_DOWN
#define LCD_SYMBOL_SPLIT_CIRCLE			0x16
#define LCD_SYMBOL_YIELD				LCD_SYMBOL_SPLIT_CIRCLE
#define LCD_SYMBOL_ARROW_RETURN			0x17
#define LCD_SYMBOL_CARRIAGE_RETURN		LCD_SYMBOL_ARROW_RETURN
#define LCD_SYMBOL_RETURN				LCD_SYMBOL_ARROW_RETURN
#define LCD_SYMBOL_ARROW_UP				0x18
#define LCD_SYMBOL_UP					LCD_SYMBOL_ARROW_UP
#define LCD_SYMBOL_ARROW_DOWN			0x19
#define LCD_SYMBOL_DOWN					LCD_SYMBOL_ARROW_DOWN
#define LCD_SYMBOL_ARROW_RIGHT			0x1A
#define LCD_SYMBOL_RIGHT				LCD_SYMBOL_ARROW_RIGHT
#define LCD_SYMBOL_ARROW_LEFT			0x1B
#define LCD_SYMBOL_LEFT					LCD_SYMBOL_ARROW_LEFT
#define LCD_SYMBOL_SCROLL_UP			0x1E
#define LCD_SYMBOL_TRIANGLE_UP			LCD_SYMBOL_SCROLL_UP
#define LCD_SYMBOL_TRIANGLE				LCD_SYMBOL_SCROLL_UP
#define LCD_SYMBOL_SCROLL_DOWN			0x1F
#define LCD_SYMBOL_TRIANGLE_DOWN		LCD_SYMBOL_SCROLL_DOWN

// MISCELLANEOUS (Only ROM code A02 / English font, unless otherwise noted)
#define LCD_SYMBOL_BLANK				0x20	// Both standard font types
#define LCD_SYMBOL_HOUSE				0x7F
#define LCD_SYMBOL_ALPHA_LOWER			0x90
#define LCD_SYMBOL_PROPORTIONALITY		LCD_SYMBOL_ALPHA_LOWER
#define LCD_SYMBOL_NOTE					0x91
#define LCD_SYMBOL_PI_LOWER				0x93
#define LCD_SYMBOL_PI					LCD_SYMBOL_PI_LOWER
#define LCD_SYMBOL_SIGMA_UPPER			0x94
#define LCD_SYMBOL_SUMMATION			LCD_SYMBOL_SIGMA_UPPER
#define LCD_SYMBOL_SIGMA_LOWER			0x95
#define LCD_SYMBOL_BEAMED_NOTES			0x96
#define LCD_SYMBOL_NOTES				LCD_SYMBOL_BEAMED_NOTES
#define LCD_SYMBOL_TAU_LOWER			0x97
#define LCD_SYMBOL_BELL					0x98
#define LCD_SYMBOL_THETA_LOWER			0x99
#define LCD_SYMBOL_OMEGA_UPPER			0x9A
#define LCD_SYMBOL_DELTA_LOWER			0x9B
#define LCD_SYMBOL_PARTIAL_DIFFERENTIAL	LCD_SYMBOL_DELTA_LOWER
#define LCD_SYMBOL_INFINITY				0x9C
#define LCD_SYMBOL_HEART				0x9D
#define LCD_SYMBOL_EPSILON_LOWER		0x9E
#define LCD_SYMBOL_INTERSECTION			0x9F
#define LCD_SYMBOL_DOUBLE_BAR			0xA0
#define LCD_SYMBOL_DOUBLE_VERTICAL		LCD_SYMBOL_DOUBLE_BAR
#define LCD_SYMBOL_MAGNITUDE			LCD_SYMBOL_DOUBLE_BAR
#define LCD_SYMBOL_PARALLEL				LCD_SYMBOL_DOUBLE_BAR
#define LCD_SYMBOL_PAUSE				LCD_SYMBOL_DOUBLE_BAR
#define LCD_SYMBOL_LATERAL_CLICK		0xA0
#define LCD_SYMBOL_CENT					0xA2
#define LCD_SYMBOL_POUND				0xA3
#define LCD_SYMBOL_CURRENCY				0xA4
#define LCD_SYMBOL_YEN					0xA5
#define LCD_SYMBOL_BROKEN_PIPE			0xA6
#define LCD_SYMBOL_BROKEN_BAR			LCD_SYMBOL_BROKEN_PIPE
#define LCD_SYMBOL_SECTION				0xA7
#define LCD_SYMBOL_FUNCTION				0xA8
#define LCD_SYMBOL_HOOKED_F				LCD_SYMBOL_FUNCTION
#define LCD_SYMBOL_FLORIN				LCD_SYMBOL_FUNCTION
#define LCD_SYMBOL_GUILDER				LCD_SYMBOL_FUNCTION
#define LCD_SYMBOL_COPYRIGHT			0xA9
#define LCD_SYMBOL_SUPERIOR_A			0xAA
#define LCD_SYMBOL_GUILLEMET_LEFT		0xAB
#define LCD_SYMBOL_REVERSE_R			0xAD
#define LCD_SYMBOL_RESERVED				0xAE
#define LCD_SYMBOL_TURNED_COMMA			0xAF
#define LCD_SYMBOL_ORDINAL				0xB0
#define LCD_SYMBOL_DEGREES				LCD_SYMBOL_ORDINAL
#define LCD_SYMBOL_PLUS_MINUS			0xB1
#define LCD_SYMBOL_SUPERSCRIPT_2		0xB2
#define LCD_SYMBOL_SUPERSCRIPT_3		0xB3
#define LCD_SYMBOL_MU_LOWER				0xB5
#define LCD_SYMBOL_MICRO				LCD_SYMBOL_MU_LOWER
#define LCD_SYMBOL_PILCROW				0xB6
#define LCD_SYMBOL_PARAGRAPH			LCD_SYMBOL_PILCROW
#define LCD_SYMBOL_BULLET				0xB7
#define LCD_SYMBOL_DOT					LCD_SYMBOL_BULLET
#define LCD_SYMBOL_SMALL_SQUARE			LCD_SYMBOL_BULLET
#define LCD_SYMBOL_OMEGA_LOWER			0xB8
#define LCD_SYMBOL_SUPERSCRIPT_1		0xB9
#define LCD_SYMBOL_SUPERIOR_O			0xBA
#define LCD_SYMBOL_GUILLEMET_RIGHT		0xBB
#define LCD_SYMBOL_ONE_FOURTH			0xBC
#define LCD_SYMBOL_FRACTION_1_4			LCD_SYMBOL_ONE_FOURTH
#define LCD_SYMBOL_ONE_HALF				0xBD
#define LCD_SYMBOL_FRACTION_1_2			LCD_SYMBOL_ONE_HALF
#define LCD_SYMBOL_THREE_FOURTHS		0xBE
#define LCD_SYMBOL_FRACTION_3_4			LCD_SYMBOL_THREE_FOURTHS
#define LCD_SYMBOL_MULTIPLICATION		0xD7
#define LCD_SYMBOL_PHI_UPPER			0xD8
#define LCD_SYMBOL_BETA_LOWER			0xDF
#define LCD_SYMBOL_OBELUS				0xF7
#define LCD_SYMBOL_DIVISION				LCD_SYMBOL_OBELUS
#define LCD_SYMBOL_PHI_LOWER			0xF8
#define LCD_SYMBOL_CONTOUR_INTEGRAL		LCD_SYMBOL_PHI_LOWER
#define LCD_SYMBOL_BLOCK				0xFF	// Only ROM code A00 / Japanese kana font

#pragma endregion


#ifndef NO_ITTYBITTY_CHARS

namespace IttyBitty
{
#pragma region CUSTOM LCD CHARACTER FLASH CONSTANT DECLARATIONS

	// Miscellaneous symbols
	EXTERN PROGMEM CBYTE LCD_CHAR_CHECKMARK[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_BOX_EMPTY[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_BOX_CHECKMARK[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_WARNING[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_NOT_ALLOWED[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_LIGHTNING[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_NOTES[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_CLOCK_A[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_CLOCK_B[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_HOURGLASS_1[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_HOURGLASS_2[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_HOURGLASS_3[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_HOURGLASS_4[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ANGLE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ANGLE_2[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_CLOCKWISE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_COUNTER_CCW[8];


	// Shape (outline) icons
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_CIRCLE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_ROUND[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_OVAL[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_CUSHION[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_SQUARE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_DIAMOND[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_BAGUETTE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_EMERALD[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_TRILLIANT[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_TRIANGLE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_SHAPE_SPECIAL[8];


	// Small arrow icons
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_UP_SMALL[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_DOWN_SMALL[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_LEFT_SMALL[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_RIGHT_SMALL[8];

	// Medium arrow icons
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_UP[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_DOWN[8];

	// Large arrow icons
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_LEFT_LARGE[8];
	EXTERN PROGMEM CBYTE LCD_CHAR_ARROW_RIGHT_LARGE[8];

#pragma endregion
};

#endif	// #ifndef NO_ITTYBITTY_CHARS

#endif
